config/routes.rb
Rails.application.routes.draw do
  resources :pins
  devise_for :users
  root "articles#index"
  resources :articles do
    resources :comments
    resources :likes
  end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
    belongs_to :author, class_name: 'User'
    include Visible
    has_one_attached :image
    has_many :comments, dependent: :destroy
    has_many :likes, dependent: :destroy
    validates :title, presence: true
    validates :body, presence: true, length: { minimum: 10 }

    scope :public_articles, ->(status = "public"){
     where('status = ?',"#{status}")
     }
    scope :archived_articles, ->(status = "archived"){
     where('status = ?',"#{status}")
     }
    scope :private_articles, ->(status = "private"){
      where('status = ?',"#{status}")
      }

    scope :ordered, ->(direction = :desc) {order(created_at: direction)}
    scope :with_authors, -> {includes(:author)}
    scope :search, ->(query) do
        return if query.blank?
        where('title LIKE ?', "%#{query.squish}%")
      end
end

app/models/comment.rb
class Comment < ApplicationRecord
  include Visible

  belongs_to :article
end

app/models/concerns/visible.rb
module Visible
    extend ActiveSupport::Concern

    VALID_STATUSES = ['public', 'private', 'archived']
  
    included do
      validates :status, inclusion: { in: VALID_STATUSES }
    end
  
    class_methods do
      def public_count
        where(status: 'public').count
      end
      def private_count
        where(status: 'private').count
      end
        def archived_count
        where(status: 'archived').count
       end
    end
  
    def archived?
      status == 'archived'
    end
  end
  
  
  

app/models/ike.rb
class Ike < ApplicationRecord
  belongs_to :article
  belongs_to :user
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :article
  belongs_to :user
end

app/models/pin.rb
class Pin < ApplicationRecord
    has_one_attached :image
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable,:rememberable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :validatable
  has_many :articles, foreign_key: :author_id, dependent: :destroy
  has_many :likes, dependent: :destroy
  ROLES = {
    user: 0,
    admin: 1
  }.with_indifferent_access.freeze

  enum role: ROLES
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    include Pundit
rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized
private
def user_not_authorized
    flash[:alert] = "You are not authorized to perform this action."
    redirect_to(request.referrer || root_path)
end
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :authenticate_user!, only: %i[new create edit update destroy] 

  def index
    authorize Article
    @articles = Article.ordered.with_authors
    @articles = Article.ordered.with_authors.paginate( :page => params[:page], per_page: 2).search(params[:query])
  end

  def show_pub
    
     if params[:commit] == "Public"
     @articles = Article.ordered.with_authors.paginate(:page => params[:page], per_page:
    2).public_articles
    
     elsif params[:commit] == "Private"
     @articles = Article.ordered.with_authors.paginate(:page => params[:page], per_page:
    2).private_articles
    
     else
     @articles = Article.ordered.with_authors.paginate(:page => params[:page], per_page:
    2).public_articles

    end
    end

  def show
    @article = Article.find(params[:id])
    authorize @article
  end
  def new
    authorize Article
    @article = Article.new
  end

  def create
    authorize Article
    @article = Article.new(article_params)
    @article.author = current_user
   
    if @article.save
      redirect_to @article
    else
      render :new, status: :unprocessable_entity
    end
  end
  def edit
    @article = Article.find(params[:id])
    authorize @article
  end

  def update
    @article = Article.find(params[:id])
    authorize @article
    
    

    if @article.update(article_params)
      redirect_to @article
    else
      render :edit, status: :unprocessable_entity
    end
  end
  def destroy
    @article = Article.find(params[:id])
    authorize @article
    @article.destroy

    redirect_to root_path
  end
  private
  def article_params
    params.require(:article).permit(:title, :body, :status, :image)
  end

end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
   
    def create
        @article = Article.find(params[:article_id])
        @comment = @article.comments.create(comment_params)
        redirect_to article_path(@article)
      end
      def destroy
        @article = Article.find(params[:article_id])
        @comment = @article.comments.find(params[:id])
        @comment.destroy
        redirect_to article_path(@article)
      end
      private
      def comment_params
        params.require(:comment).permit(:commenter, :body, :status)
      end
end

app/controllers/likes_controller.rb
class LikesController < ApplicationController

    before_action :find_article
    before_action :find_like, only: [:destroy]
    

    def create
        if already_liked?
          flash[:notice] = "You can't like more than once"
        else
          @article.likes.create(user_id: current_user.id)
        end
        redirect_to article_path(@article)
      end
    def destroy
        if !(already_liked?)
          flash[:notice] = "Cannot unlike"
        else
          @like.destroy
        end
        redirect_to article_path(@article)
      end
      def find_like
        @like = @article.likes.find(params[:id])
     end
 
   private  
   def find_article
    @article = Article.find(params[:article_id])
  end
  private
  def already_liked?
    Like.where(user_id: current_user.id, article_id:
    params[:article_id]).exists?
  end
  private
  def find_article
  @article = Article.find(params[:article_id])
  end
end

app/controllers/pins_controller.rb
class PinsController < ApplicationController
  before_action :set_pin, only: %i[ show edit update destroy ]

  # GET /pins or /pins.json
  def index
    @pins = Pin.all
  end

  # GET /pins/1 or /pins/1.json
  def show
  end

  # GET /pins/new
  def new
    @pin = Pin.new
  end

  # GET /pins/1/edit
  def edit
  end

  # POST /pins or /pins.json
  def create
    @pin = Pin.new(pin_params)

    respond_to do |format|
      if @pin.save
        format.html { redirect_to @pin, notice: "Pin was successfully created." }
        format.json { render :show, status: :created, location: @pin }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @pin.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /pins/1 or /pins/1.json
  def update
    respond_to do |format|
      if @pin.update(pin_params)
        format.html { redirect_to @pin, notice: "Pin was successfully updated." }
        format.json { render :show, status: :ok, location: @pin }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @pin.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /pins/1 or /pins/1.json
  def destroy
    @pin.destroy
    respond_to do |format|
      format.html { redirect_to pins_url, notice: "Pin was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_pin
      @pin = Pin.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def pin_params
      params.require(:pin).permit(:title, :caption)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/pins_helper.rb
module PinsHelper
end

app/views/articles/_form.html.erb
<%= form_with model: article do |form| %>
  <div>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
    <% article.errors.full_messages_for(:title).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>
<div>
  <%= form.label :status %><br>
  <%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
</div>
  <div>
    <%= form.label :body %><br>
    <%= form.text_area :body %><br>
    <% article.errors.full_messages_for(:body).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>
 <div class="field">
  <%= form.label :image %>
  <%= form.file_field :image %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<%= render "form", article: @article %>

app/views/articles/index.html.erb
<h1>All posts</h1>
This blog has <%= Article.public_count %> public posts!
<br>

<%= form_with method: :get do |form| %>
  <%= form.label :query, "Search for:" %>
  <%= form.text_field :query, value: params[:query] %>
  <%= form.submit "Search" %>
<% end %>

 

<a href="/">articles</a>
(<%= Article.public_count %>
 <a href="/articles/?a=public">public</a>
<%= Article.private_count %>
<a href="/articles/?a=private">private</a>
 <%= Article.archived_count %>
 <a href="/articles/?a=archived">archived)</a>
 <br>
<br>

 <%= form_with method: :get do |form| %>
<br>

 <%= form_with method: :get%>
 <%= form_tag('ArticleController/show_pub', method: 'get') do %>
 <%= submit_tag "Public", :method => 'show_pub' %>
 <%= submit_tag "Archived", :method => 'show_pub' %>
 <%= submit_tag "Private", :method => 'show_pub' %>
 <% end %>


<ul>
  <% @articles.each do |article| %>
    <% unless article.archived? %>
      <li>
        <%= link_to article.title, article %>
      </li>
    <% end %>
    <p>
     <strong>User name:</strong>
       <%= article.author.username %>
     </p>
    <p><%= article.body %></p>
    <p>
      <i><%= article.created_at %></i>
    </p>
    <p><%= article.likes.count %> <%= (article.likes.count) == 1 ? 'Like' : 'Likes'%></p>
    <% end %>
    <% end %>
</ul>
<%= will_paginate @article %>
<%= link_to "New Article", new_article_path %>

app/views/articles/new.html.erb
<h1>New Article</h1>
<%= render "form", article: @article %>

app/views/articles/show.html.erb
<h1><%= @article.title %></h1>
<p>
  <strong>User name:</strong>
<%= @article.author.username %>
</p>
<p><%= @article.body %></p>

<p>
      <i><%= @article.created_at %></i>
</p>

<% pre_like = @article.likes.find { |like| like.user_id == current_user.id} %>
<% if pre_like %>
  <%= button_to 'Unlike', article_like_path(@article, pre_like), method: :delete %>
<% else %>
  <%= button_to 'Like', article_likes_path(@article), method: :post %>
<% end %>

 
<p><%= @article.likes.count %> <%= (@article.likes.count) == 1 ? 'Like' : 'Likes'%></p>

<div style="width:400px; height:auto"> 
<%= image_tag(@article.image) %>
</div>
<ul>
  <% if policy(@article).update? %>
  <li><%= link_to "Edit", edit_article_path(@article) %></li> |
  <% end %>
  <% if policy(@article).destroy? %>
  <li><%= link_to "Destroy", article_path(@article),
                  method: :delete,
                  data: { confirm: "Are you sure?" } %></li>
  <% end %>
</ul>


<h2>Comments</h2>
<%= render @article.comments %>

<h2>Add a comment:</h2>
<%= render 'comments/form' %>

<li><%= link_to 'Back', articles_path %></li>

app/views/comments/_comment.html.erb
<% unless comment.archived? %>
  <p>
    <strong>Comment title:</strong>
    <%= comment.commenter %>
  </p>

  <p>
    <strong>Comment:</strong>
    <%= comment.body %>
  </p>
  <p>
  <%= link_to 'Destroy Comment', [comment.article, comment],
              method: :delete,
              data: { confirm: "Are you sure?" } %>
</p>
<% end %>

app/views/comments/_form.html.erb
<%= form_with model: [ @article, @article.comments.build ] do |form| %>
  <p>
    <%= form.label :commenter %><br>
    <%= form.text_field :commenter %>
  </p>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  

<p>
  <%= form.label :status %><br>
  <%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
</p>


  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blogg</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <header>
  <% if user_signed_in? %>
    <%= current_user.username %> 
     <% if current_user.admin? %>
     [admin] 
     <% end %>
    | <%= link_to 'Logout' , destroy_user_session_path, method: :delete, data: {confirm: 'Do you want to logout?'}  %> 
  <% else %>
 <%= link_to 'Login' , new_user_session_path %> 
  <% end %>
  </header>
   <p id="notice"><%= notice %></p>
   <p id="alert"><%= alert %></p>
    <%= yield %>
  </body>
</html>

app/views/pins/_form.html.erb
<%= form_with(model: pin) do |form| %>
  <% if pin.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(pin.errors.count, "error") %> prohibited this pin from being saved:</h2>

      <ul>
        <% pin.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :caption %>
    <%= form.text_area :caption %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/pins/edit.html.erb
<h1>Editing Pin</h1>

<%= render 'form', pin: @pin %>

<%= link_to 'Show', @pin %> |
<%= link_to 'Back', pins_path %>

app/views/pins/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Pins</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Caption</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @pins.each do |pin| %>
      <tr>
        <td><%= pin.title %></td>
        <td><%= pin.caption %></td>
        <td><%= link_to 'Show', pin %></td>
        <td><%= link_to 'Edit', edit_pin_path(pin) %></td>
        <td><%= link_to 'Destroy', pin, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Pin', new_pin_path %>

app/views/pins/new.html.erb
<h1>New Pin</h1>

<%= render 'form', pin: @pin %>

<%= link_to 'Back', pins_path %>

app/views/pins/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @pin.title %>
</p>

<p>
  <strong>Caption:</strong>
  <%= @pin.caption %>
</p>

<%= link_to 'Edit', edit_pin_path(@pin) %> |
<%= link_to 'Back', pins_path %>